/**
 * Groove Editor
 *
 * Version 0.0.4
 *
 * Copyright (c) 2017 Michael Ochmann
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

#include <iostream>
#include <ncurses/ncurses.hpp>
#include <Editor.hpp>
#include <Highlighter.hpp>

int main(int argc, char* argv[]) {
	std::unique_ptr<groove::Editor> editor;

	if (argc > 1)
		editor = std::make_unique<groove::Editor>(argv[1]);
	else
		editor = std::make_unique<groove::Editor>();

	groove::ncurses::ncurses curses;
	curses.init();
	curses.flush();

	while(editor->mode() != groove::Mode::QUIT)
	{
		editor->render();
		int input = getch();                // Blocking until input
		editor->input(input);
	}

	curses.quit();

	return 0;
}