#pragma once

#include <string>
#include <ncurses/ncurses.hpp>
#include <vector>
#include <unordered_map>
#include <regex>

namespace groove {

	typedef std::vector<std::pair<std::regex, ncurses::Colors>> RulesList;

	inline std::pair<std::regex, ncurses::Colors> make_pair(std::string regex, ncurses::Colors color) {
		return std::make_pair(std::regex(regex), color);
	};

	enum class Syntax {
		DEFAULT,
		CPP
	};

	class Highlighter {
	private:
		std::string line;
	public:
		static std::unordered_map<Syntax, RulesList> Syntaxes;
		static RulesList list;
		Highlighter(std::string line) : line(line) {}
		std::unordered_map<long, std::pair<long, ncurses::Colors>> get();
	};

}