#include <modes/Insert.hpp>
#include <Editor.hpp>
#include <iostream>

namespace groove {
	namespace modes {
		
		void Insert::input(int c) {
			if (this->editor.movement(c))
				return;
			switch (c) {
				case 27:
					this->editor.mode_ = groove::Mode::EDIT;
					break;
				case KEY_ENTER:
				case 10:
				{
					std::string appendix;
					appendix = "";
					if (this->editor.buffer->at(this->editor.y).size() > this->editor.x) {
						appendix = this->editor.buffer->at(this->editor.y).substr(this->editor.x, this->editor.buffer->at(this->editor.y).size());
						this->editor.buffer->at(this->editor.y) = this->editor.buffer->at(this->editor.y).substr(0, this->editor.x);
					}
					this->editor.buffer->insert(this->editor.y);
					this->editor.y++;
					this->editor.buffer->linebuffer().at(this->editor.y) += appendix;
					this->editor.x = 0;
					this->editor.scrollDown();
				}
					break;
				case KEY_BACKSPACE:
					if (this->editor.x - 1 >= 0) {
						this->editor.x--;
						this->editor.buffer->remove(this->editor.y, this->editor.x);
					}
					else {
						if (this->editor.buffer->at(this->editor.y).size() > 0 && this->editor.y > 0) {
							int oldLength = static_cast<int>(this->editor.buffer->at(this->editor.y - 1).size());
							this->editor.buffer->at(this->editor.y - 1) += this->editor.buffer->at(this->editor.y);
							this->editor.buffer->remove(this->editor.y);
							this->editor.y--;
							this->editor.x = oldLength;
						}
						else {
							if (this->editor.y - 1 >= 0) {
								this->editor.buffer->remove(this->editor.y);
								this->editor.y--;
								this->editor.x = static_cast<int>(this->editor.buffer->at(this->editor.y).length());
							}
						}
					}
					this->editor.scrollUp();
					break;
				case KEY_DC:
					if (this->editor.buffer->at(this->editor.y).length() > this->editor.x)
						this->editor.buffer->deleteChar(this->editor.y, this->editor.x);
					else {
						if (this->editor.buffer->at(this->editor.y).empty() && this->editor.buffer->linebuffer().size() - 1 > this->editor.y)
							this->editor.buffer->remove(this->editor.y);
						else if (this->editor.buffer->linebuffer().size() - 1 > this->editor.y) {
							this->editor.buffer->at(this->editor.y) += this->editor.buffer->at(this->editor.y + 1);
							this->editor.buffer->remove(this->editor.y + 1);
						}
					}
					break;
				case KEY_BTAB:
				case KEY_CTAB:
				case KEY_STAB:
				case KEY_CATAB:
				case 9:
					this->editor.buffer->at(this->editor.y).insert(this->editor.x, 4, ' ');
					this->editor.x += 4;
					break;
				default:
				{
					switch (c) {
						case '{':
						case '[':
							this->editor.buffer->at(this->editor.y).insert(this->editor.x, 1, c + 2);
							break;
						case '(':
							this->editor.buffer->at(this->editor.y).insert(this->editor.x, 1, c + 1);
							break;
					}
					this->editor.buffer->at(this->editor.y).insert(this->editor.x, 1, char(c));
					if (this->editor.lastChar != 195 && this->editor.lastChar != 182)
						this->editor.x++;
					this->editor.lastChar = char(c);
				}
				break;
			}
		}
	}
}