#include <modes/Save.hpp>
#include <Editor.hpp>
#include <iostream>

namespace groove {
	namespace modes {

		void Save::input(int c) {
			switch (c) {
				case 'n':
				case 27:
					this->editor.mode_ = groove::Mode::EDIT;
					break;
				case 'y':
					if (!this->editor.save())
						std::cerr << "Could not write to file: '" << this->editor.filename << "'\n";
					this->editor.buffer->changed = false;
					this->editor.mode_ = groove::Mode::EDIT;
					break;
			}
		}

		std::string Save::status() {
			this->status_ = "Save file '" + this->editor.filename + "'? [Y/N]:";
			return this->status_;
		}

	}
}